#include "adevs.h"
#include <cmath>
#include <iostream>
using namespace std;

double f(double x)
{
	return x*sin(x);
}

/// Solves dx/dt = xsin(x) using DAB1
int main(int argc, char** argv)
{
	double D = atof(argv[1]);
	double tend = atof(argv[2]);
	double x = atof(argv[3]);
	double t = 0.0;
	qoden2<1> q;
	q.setParams(D);
	double dx = f(x);
	q.init(&x,&dx);
	cout << t << " " << x << endl;
	while (t < tend)
	{
		t += q.ta();
		cout << t << " " << q.out() << endl;
		dx = f(q.out());
		q.integ(q.ta(),&dx);
	}
	return 0;
}
