#ifndef __IOtype_h_
#define __IOtype_h_

class IOtype
{
	public:
		typedef enum { CDF, CELL, UNKNOWN } SourceType;
		IOtype():
		source(UNKNOWN),
		index(-1)
		{
		}
		IOtype(SourceType type, int index, double value):
		source(type),
		index(index),
		value(value)
		{
		}
		IOtype(const IOtype& src):
		source(src.source),
		index(src.index),
		value(src.value)
		{
		}
		const IOtype& operator=(const IOtype& src)
		{
			source = src.source;
			index = src.index;
			value = src.value;
			return *this;
		}
		double get_value() const { return value; }
		SourceType get_source() const { return source; }
		int get_index() const { return index; }
	private:
		SourceType source;
		int index;
		double value;
};

#endif
