#ifndef __cell_h_
#define __cell_h_
#include <adevs.h>
#include "IOtype.h"

class cell: public atomic
{
	public:
		static const port_t flux_left;
		static const port_t flux_right;
		static const port_t soln;
		static double dx;
		static double T_min;
		static double D;
		
		cell();
		cell(int x, double u0);
		cell(const cell& src);
		object* clone() const { return new cell(*this); }
		const cell& operator=(const cell& src);
		void init();
		void delta_int();
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x);
		void delta_conf(const adevs_bag<PortValue>& x);
		void output_func(adevs_bag<PortValue>& y);
		void gc_output(adevs_bag<PortValue>& y){}
		~cell(){}
		double getState() const;
		double getDerivative() const;
		unsigned long getCompCount() const { return c; }
		int getIndex() const { return index; }
	private:
		qoden2<1> q;
		double fl, fr;
		double T_last;
		unsigned long c;
		int index;
		double dq;
};

#endif
