#ifndef __multicell_h_
#define __multicell_h_
#include <adevs.h>
#include <vector>
#include "IOtype.h"
#include "cell.h"
#include "CDF.h"

class multicell: public devsn 
{
	public:
		multicell(const std::vector<double>& U0);
		multicell(const multicell& src);
		netExec* getNetExec() { return nx; }
		object* clone() const { return new multicell(*this); }
		void report() { nx->report(); }
		~multicell() 
		{
			delete nx;
		}
	private:
		class space_manager: public netExec
		{
			public:
				space_manager(const std::vector<double>& U0, devs* parent);
				space_manager(const space_manager& src, devs* parent);
				void init(){ passivate(); }
				void delta_int(){}
				void delta_ext(stime_t e, const adevs_bag<PortValue>& x){}
				void delta_conf(const adevs_bag<PortValue>& x){}
				void output_func(adevs_bag<PortValue>& y){}
				void gc_output(adevs_bag<PortValue>& g){}
				void gc_models(adevs_set<devs*>& g){}
				void route(const PortValue& pv, devs* src, adevs_bag<EventReceiver>& r);
				void getComponents(adevs_set<devs*>& c);
				void report();
				~space_manager(){}
			private:	
				std::vector<CDF> cdfs;
				std::vector<cell> cells;
		};
		space_manager* nx;
};

#endif
