#include "adevs_exceptions.h"
/// Primes numbers used as table sizes for closed hashing
/// See adevs_hashtable.h for the intended application.

/* Table of 17 primes each at least 2 times the previous*/
static const int table_size = 17;
static const int primes[] = {
	101,
	211,
	431,
	863,
	1733,
	3467,
	6947,
	13901,
	27803,
	55609,
	111227,
	222461,
	444929,
	889871,
	1779761,
	3559537,
	7119103
};

int get_prime(int k)
{
	if (k >= table_size)
		THROW_BASE_EXCEPTION("Out of primes!");
	return primes[k];
}
