#include <adevs.h>
#include <iostream>
#include "gcd.h"

int main() 
{
	try
	{
		std::cout << "Test 11" << std::endl;
		staticDigraph* model = new staticDigraph;
		gcd* c = new gcd(10.0,2.0,100,true);
		genr* g = new genr(10.0,100,true);
		model->couple(g,g->signal,c,c->in);
		model->setTimeCurrent(0.0);
		model->setTimeLast(0.0);
		model->init();
		pdevs_coord* coord = new pdevs_coord(model);
		for (int i = 0; i < 2; i++)
		{
			coord->computeInputOutput();
			if (coord->timeNext() > coord->timeLast() && coord->timeNext() < INFINITY)
				coord->computeDeltaFunc(
					coord->timeCurrent()+(coord->timeNext()-coord->timeCurrent())/2.0);
			coord->computeInputOutput();
			coord->computeDeltaFunc(coord->timeNext());
			coord->endOfCycle();
		}
		coord->detachModel();
		coord->attachModel((devsn*)(model->clone()));
		for (int i = 0; i < 10; i++)
		{
			coord->computeInputOutput();
			if (coord->timeNext() > coord->timeLast() && coord->timeNext() < INFINITY)
				coord->computeDeltaFunc(
					coord->timeCurrent()+(coord->timeNext()-coord->timeCurrent())/2.0);
			coord->computeInputOutput();
			coord->computeDeltaFunc(coord->timeNext());
			coord->endOfCycle();
		}
		std::cout << "Test done" << std::endl;
	}
	catch(adevs_exception& err)
	{
		std::cout << err.getErrorMsg() << std::endl;
		assert(false);
	}
return 0;
}
