#include <adevs_pqueue.h>
#include <iostream>
#include <assert.h>

void testa()
{
	adevs_pqueue<int,int> q;
	q.insert(0,0);
	q.removeMinimum();
	q.insert(0,0);
	q.insert(0,1);
	assert(q.minPriority() == 1);
}

void test1()
{
	adevs_pqueue<int,int> q;
	for (int i = 0; i < 10; i++)
	{
		q.insert(i,i);
		assert(q.getSize() == i+1);
		assert(q.minPriority() == 0);
		assert(q.getMinimum() == 0);
	}
	for (int i = 0; i < 10; i++)
	{
		assert(q.getSize() == 10-i);
		assert(q.minPriority() == i);
		assert(q.getMinimum() == i);
		q.removeMinimum();
	}
}

void test2()
{
	adevs_pqueue<int,int> q;
	q.insert(1,1);
	q.insert(10,10);
	q.insert(5,5);
	assert(q.minPriority() == 1);
	q.removeMinimum();
	assert(q.getSize() == 2);
	assert(q.minPriority() == 5);
	q.insert(3,3);
	q.insert(4,4);
	assert(q.minPriority() == 3);
	q.removeMinimum();
	assert(q.minPriority() == 4);
	q.removeMinimum();
	assert(q.minPriority() == 5);
	q.removeMinimum();
	assert(q.minPriority() == 10);
	q.removeMinimum();
	assert(q.getSize() == 0);
}

void test3()
{
	adevs_pqueue<int,int> q;
	q.insert(5,5);
	q.insert(10,10);
	q.insert(1,1);
	assert(q.getSize() == 3);
	q.remove(5);
	assert(q.getSize() == 2);
	assert(q.minPriority() == 1);
	q.remove(1);
	assert(q.getSize() == 1);
	assert(q.minPriority() == 10);
}

void test4()
{
	adevs_pqueue<int,int> q;
	for (int i = 0; i < 10; i++)
	{
		q.insert(i,i);
	}
	adevs_pqueue<int,int> q1(q);
	adevs_pqueue<int,int> q2 = q;
	for (int i = 0; i < 10; i++)
	{
		assert(q.getSize() == q1.getSize());
		assert(q.getSize() == q2.getSize());
		assert(q.minPriority() == q1.minPriority());
		assert(q.minPriority() == q2.minPriority());
		assert(q.getMinimum() == q1.getMinimum());
		assert(q.getMinimum() == q2.getMinimum());
		q.remove(i);
		q1.remove(i);
		q2.remove(i);
	}
}

void test5()
{
	adevs_pqueue<int,int> q;
	q.insert(1,2);
	q.insert(2,3);
	q.remove(2);
	assert(q.minPriority() == 2);
	assert(q.getMinimum() == 1);
}

void test6()
{
	adevs_pqueue<int,int*> q;
	int* one = new int(1);
	int* two = new int(1);
	q.insert(one,1);
	q.insert(two,1);
	q.remove(one);
	assert(!q.isEnqueued(one));
	assert(q.isEnqueued(two));
}

void test7()
{
	adevs_pqueue<int,int> q;
	q.insert(2,2);
	q.insert(3,3);
	q.insert(2,4);
	q.insert(2,4);
	assert(q.getMinimum() == 3);
	q.removeMinimum();
	assert(q.getMinimum() == 2);
	q.insert(3,1);
	assert(q.getMinimum() == 3);
}

void test8()
{
	adevs_pqueue<int,int> q;
	for (int i = 0; i < 2000; i++)
	{
		q.insert(i,i);
		assert(q.getMinimum() == i);
		q.insert(i,i);
		assert(q.getMinimum() == i);
		q.remove(i);
		assert(q.getSize() == 0);
	}
}

int main () 
{
	testa();
	test1();
	test2();
	test3();
	test4();
	test5();
	test6();
	test7();
	test8();
	return 0;
}
